QT += core gui widgets printsupport serialport
QT += 3dcore 3drender 3dinput 3dlogic 3dextras 3danimation

CONFIG += c++11

# MacOs app icon
ICON = src/entrypoints/groundstation/assets/icons/SkywardHub.icns

# Windows app icon
RC_ICONS = src/entrypoints/groundstation/assets/icons/SkywardHub.ico

INCLUDEPATH += \
    src/shared \
    libs/mavlink-skyward-lib \
    libs/backward-cpp

SOURCES += \
    src/shared/Modules/Empty/EmptyModule.cpp \
    src/shared/Modules/ValuesConverterViewer/ValuesViewerConfigPanel.cpp \
    src/shared/Modules/ValuesConverterViewer/ValueElement.cpp \
    src/shared/Modules/ValuesConverterViewer/ValuesConverterViewerModule.cpp \
    src/shared/Modules/OutgoingMessagesViewer/OutgoingMessagesViewerModule.cpp \
    src/shared/Modules/TimerController/TimerControllerModule.cpp \
    src/shared/Modules/OrientationVisualizer/OrientationVisualizer.cpp \
    src/shared/Modules/MainStateViewer/MainStateViewer.cpp \
    src/shared/Modules/PayloadStateViewer/PayloadStateViewer.cpp \
    src/shared/Modules/RigStateViewer/RigStateViewer.cpp \
    src/shared/Modules/FileStream/FileStreamModule.cpp \
    src/shared/Modules/Graph/Graph.cpp \
    src/shared/Modules/Test/TestModule.cpp \
    src/shared/Modules/ModulesList.cpp \
    src/shared/Modules/Module.cpp \
    src/shared/Modules/Splitter/Splitter.cpp \
    src/shared/Modules/CommandPad/CommandPad.cpp \
    src/shared/Modules/CommandPad/MessageFormElement.cpp \
    src/shared/Modules/IncomingMessagesViewer/IncomingMessagesViewerModule.cpp \
    src/shared/Modules/CompactCommandPad/CompactCommandPad.cpp \
    src/shared/Modules/CompactCommandPad/SendThread.cpp \
    src/shared/Modules/CompactCommandPad/CommandSelector.cpp \
    src/shared/Modules/Tabs/TabsModule.cpp \
    src/shared/Modules/ModuleInfo.cpp \
    src/shared/Modules/Mavlink/Ports/MavlinkPort.cpp \
    src/shared/Modules/Mavlink/Ports/SerialPort.cpp \
    src/shared/Modules/Mavlink/Ports/UdpPort.cpp \
    src/shared/Modules/Mavlink/BaseMavlinkModule.cpp \
    src/shared/Modules/Mavlink/MavlinkCodec.cpp \
    src/shared/Modules/Mavlink/SerialMavlinkModule.cpp \
    src/shared/Modules/Mavlink/UdpMavlinkModule.cpp \
    src/shared/Modules/ValvesViewer/ValvesViewer.cpp \
    src/shared/Core/XmlObject.cpp \
    src/shared/Core/QCustomPlot/QCustomPlot.cpp \
    src/shared/Core/MessageBroker/MessageBroker.cpp \
    src/shared/Core/SkywardHubCore.cpp \
    src/shared/Core/Message/Filter.cpp \
    src/shared/Core/Message/Field.cpp \
    src/shared/Core/Message/Topic.cpp \
    src/shared/Core/Message/Message.cpp \
    src/shared/Core/Window/Window.cpp \
    src/shared/Components/FilterSelector/FilterSelector.cpp \
    src/shared/Components/ModulesPicker/ModulesPicker.cpp \
    src/shared/Components/SaveConfigurationDialog/SaveConfigurationDialog.cpp \
    src/shared/Components/ErrorDisplayer/Error.cpp \
    src/shared/Components/ErrorDisplayer/ErrorDisplayer.cpp \
    src/shared/Components/ToggleButton/ToggleButton.cpp \
    src/shared/Components/SubscriptionsPanel/SubscriptionsPanel.cpp \
    src/entrypoints/groundstation/main.cpp

HEADERS += \
    src/shared/Modules/Empty/EmptyModule.h \
    src/shared/Modules/ValuesConverterViewer/ValueElement.h \
    src/shared/Modules/ValuesConverterViewer/ValuesViewerConfigPanel.h \
    src/shared/Modules/ValuesConverterViewer/ValuesConverterViewerModule.h \
    src/shared/Modules/OutgoingMessagesViewer/OutgoingMessagesViewerModule.h \
    src/shared/Modules/TimerController/TimerControllerModule.h \
    src/shared/Modules/ModuleInfo.h \
    src/shared/Modules/OrientationVisualizer/OrientationVisualizer.h \
    src/shared/Modules/MainStateViewer/MainStatesList.h \
    src/shared/Modules/MainStateViewer/MainStateViewer.h \
    src/shared/Modules/PayloadStateViewer/PayloadStatesList.h \
    src/shared/Modules/PayloadStateViewer/PayloadStateViewer.h \
    src/shared/Modules/RigStateViewer/RigStatesList.h \
    src/shared/Modules/RigStateViewer/RigStateViewer.h \
    src/shared/Modules/FileStream/FileStreamModule.h \
    src/shared/Modules/Graph/Graph.h \
    src/shared/Modules/Test/TestModule.h \
    src/shared/Modules/SkywardHubStrings.h \
    src/shared/Modules/Splitter/Splitter.h \
    src/shared/Modules/CommandPad/MessageFormElement.h \
    src/shared/Modules/CommandPad/CommandPad.h \
    src/shared/Modules/CommandPad/MessagesList.h \
    src/shared/Modules/IncomingMessagesViewer/IncomingMessagesViewerModule.h \
    src/shared/Modules/CompactCommandPad/CompactCommandPad.h \
    src/shared/Modules/CompactCommandPad/CommandSelector.h \
    src/shared/Modules/CompactCommandPad/SendThread.h \
    src/shared/Modules/Tabs/TabsModule.h \
    src/shared/Modules/Mavlink/Ports/MavlinkPort.h \
    src/shared/Modules/Mavlink/Ports/SerialPort.h \
    src/shared/Modules/Mavlink/Ports/UdpPort.h \
    src/shared/Modules/Mavlink/MavlinkVersionHeader.h \
    src/shared/Modules/Mavlink/BaseMavlinkModule.h \
    src/shared/Modules/Mavlink/MavlinkCodec.h \
    src/shared/Modules/Mavlink/SerialMavlinkModule.h \
    src/shared/Modules/Mavlink/UdpMavlinkModule.h \
    src/shared/Modules/ModulesList.h \
    src/shared/Modules/ValvesViewer/ValvesViewer.h \
    src/shared/Modules/ValvesViewer/ValvesList.h \
    src/shared/Modules/Module.h \
    src/shared/Core/QCustomPlot/QCustomPlot.h \
    src/shared/Core/MessageBroker/MessageBroker.h \
    src/shared/Core/SkywardHubCore.h \
    src/shared/Core/XmlObject.h \
    src/shared/Core/Message/Message.h \
    src/shared/Core/Message/Filter.h \
    src/shared/Core/Message/Field.h \
    src/shared/Core/Message/Topic.h \
    src/shared/Core/Window/Window.h \
    src/shared/Core/CrashLogger.h \
    src/shared/Components/FilterSelector/FilterSelector.h \
    src/shared/Components/ModulesPicker/ModulesPicker.h \
    src/shared/Components/SaveConfigurationDialog/SaveConfigurationDialog.h \
    src/shared/Components/ErrorDisplayer/ErrorDisplayer.h \
    src/shared/Components/ErrorDisplayer/Error.h \
    src/shared/Components/ToggleButton/ToggleButton.h \
    src/shared/Components/SubscriptionsPanel/SubscriptionsPanel.h \

FORMS += \
    src/shared/Modules/ValuesConverterViewer/ValuesConverterViewerModule.ui \
    src/shared/Modules/ValuesConverterViewer/ValuesViewerConfigPanel.ui \
    src/shared/Modules/OutgoingMessagesViewer/OutgoingMessagesViewerModule.ui \
    src/shared/Modules/TimerController/TimerControllerModule.ui \
    src/shared/Modules/FileStream/FileStreamModule.ui \
    src/shared/Modules/Test/TestModule.ui \
    src/shared/Components/SaveConfigurationDialog/SaveConfigurationDialog.ui \

# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target

RESOURCES += \
    src/entrypoints/groundstation/application.qrc

win32: LIBS += -ldbghelp -lpsapi

unix: LIBS += -ldw -lunwind
unix: QMAKE_CXXFLAGS += -DBACKWARD_HAS_DW=1 -DBACKWARD_HAS_LIBUNWIND=1
